# swagger_client

SwaggerClient - the Ruby gem for the 1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build date: 2016-11-03T11:50:56.946+04:00
- Build package: class io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Аккаунт: баланс
  result = api_instance.balance_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->balance_get: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://www.1gb.ru/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::DefaultApi* | [**balance_get**](docs/DefaultApi.md#balance_get) | **GET** /balance | Аккаунт: баланс
*SwaggerClient::DefaultApi* | [**balance_lic_get**](docs/DefaultApi.md#balance_lic_get) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
*SwaggerClient::DefaultApi* | [**billing_debt_get**](docs/DefaultApi.md#billing_debt_get) | **GET** /billing/debt | Информация по дебету аккаунта
*SwaggerClient::DefaultApi* | [**billing_info_get**](docs/DefaultApi.md#billing_info_get) | **GET** /billing/info | Информация об аккаунте
*SwaggerClient::DefaultApi* | [**billing_limits_get**](docs/DefaultApi.md#billing_limits_get) | **GET** /billing/limits | Получить ограничения аккаунта
*SwaggerClient::DefaultApi* | [**dns_prolong_list_get**](docs/DefaultApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
*SwaggerClient::DefaultApi* | [**email_add_get**](docs/DefaultApi.md#email_add_get) | **GET** /email/add | Создание почтового ящика
*SwaggerClient::DefaultApi* | [**email_alias_delete_get**](docs/DefaultApi.md#email_alias_delete_get) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
*SwaggerClient::DefaultApi* | [**email_alias_list_get**](docs/DefaultApi.md#email_alias_list_get) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
*SwaggerClient::DefaultApi* | [**email_delete_get**](docs/DefaultApi.md#email_delete_get) | **GET** /email/delete | Удаление почтового ящика
*SwaggerClient::DefaultApi* | [**email_list_get**](docs/DefaultApi.md#email_list_get) | **GET** /email/list | Получить список почтовых ящиков
*SwaggerClient::DefaultApi* | [**updates_last_get**](docs/DefaultApi.md#updates_last_get) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
*SwaggerClient::DefaultApi* | [**updates_list_get**](docs/DefaultApi.md#updates_list_get) | **GET** /updates/list | Список записей аудита
*SwaggerClient::DefaultApi* | [**website_delete_get**](docs/DefaultApi.md#website_delete_get) | **GET** /website/delete | Удаление сайта
*SwaggerClient::DefaultApi* | [**website_list_get**](docs/DefaultApi.md#website_list_get) | **GET** /website/list | Список сайтов аккаунта
*SwaggerClient::AuthAPIApi* | [**auth_login_post**](docs/AuthAPIApi.md#auth_login_post) | **POST** /auth/login | Получить ключ доступа
*SwaggerClient::AuthAPIApi* | [**auth_start_get**](docs/AuthAPIApi.md#auth_start_get) | **GET** /auth/start | Получить соль
*SwaggerClient::DNSApi* | [**dns_add_get**](docs/DNSApi.md#dns_add_get) | **GET** /dns/add | Создание записи домена
*SwaggerClient::DNSApi* | [**dns_bind_get**](docs/DNSApi.md#dns_bind_get) | **GET** /dns/bind | Привязка одного домена к другому
*SwaggerClient::DNSApi* | [**dns_list_get**](docs/DNSApi.md#dns_list_get) | **GET** /dns/list | Получить список доменных имён
*SwaggerClient::DNSApi* | [**dns_prolong_list_get**](docs/DNSApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
*SwaggerClient::DNSApi* | [**dns_raw_get**](docs/DNSApi.md#dns_raw_get) | **GET** /dns/raw | Редактирование \"сырой\" зоны
*SwaggerClient::DNSApi* | [**dns_raw_managedmx_get**](docs/DNSApi.md#dns_raw_managedmx_get) | **GET** /dns/raw/managedmx | Редактировать DNS-зону
*SwaggerClient::HostingftpAPIApi* | [**ftp_list_get**](docs/HostingftpAPIApi.md#ftp_list_get) | **GET** /ftp/list | Получить список зарегистрированных аккаунтов FTP
*SwaggerClient::HostingiisAPIApi* | [**iis_list_get**](docs/HostingiisAPIApi.md#iis_list_get) | **GET** /iis/list | Список сайтов IIS
*SwaggerClient::MicrosoftSQLServerApi* | [**mssql_list_get**](docs/MicrosoftSQLServerApi.md#mssql_list_get) | **GET** /mssql/list | Получить список аккаунтов в MSSQL
*SwaggerClient::MySQLPostgresApi* | [**database_list_get**](docs/MySQLPostgresApi.md#database_list_get) | **GET** /database/list | Список аккаунтов в базах данных UNIX
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_create_get**](docs/VDSHyperVOpenVZApi.md#vds_create_get) | **GET** /vds/create | Изменение параметров VDS
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_delete_get**](docs/VDSHyperVOpenVZApi.md#vds_delete_get) | **GET** /vds/delete | Удаление VDS
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_ip_add_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_add_get) | **GET** /vds/ip/add | Добавление IP на VDS
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_ip_delete_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_delete_get) | **GET** /vds/ip/delete | Удаление IP с VDS
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_ip_list_get**](docs/VDSHyperVOpenVZApi.md#vds_ip_list_get) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_list_get**](docs/VDSHyperVOpenVZApi.md#vds_list_get) | **GET** /vds/list | Список виртуальных серверов
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_reboot_get**](docs/VDSHyperVOpenVZApi.md#vds_reboot_get) | **GET** /vds/reboot | Перезагрузка VDS
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_templates_list_get**](docs/VDSHyperVOpenVZApi.md#vds_templates_list_get) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
*SwaggerClient::VDSHyperVOpenVZApi* | [**vds_update_get**](docs/VDSHyperVOpenVZApi.md#vds_update_get) | **GET** /vds/update | Создание VDS


## Documentation for Models

 - [SwaggerClient::InlineResponse200](docs/InlineResponse200.md)
 - [SwaggerClient::InlineResponse2001](docs/InlineResponse2001.md)
 - [SwaggerClient::InlineResponse20010](docs/InlineResponse20010.md)
 - [SwaggerClient::InlineResponse20011](docs/InlineResponse20011.md)
 - [SwaggerClient::InlineResponse20012](docs/InlineResponse20012.md)
 - [SwaggerClient::InlineResponse20013](docs/InlineResponse20013.md)
 - [SwaggerClient::InlineResponse20014](docs/InlineResponse20014.md)
 - [SwaggerClient::InlineResponse2002](docs/InlineResponse2002.md)
 - [SwaggerClient::InlineResponse2003](docs/InlineResponse2003.md)
 - [SwaggerClient::InlineResponse2004](docs/InlineResponse2004.md)
 - [SwaggerClient::InlineResponse2005](docs/InlineResponse2005.md)
 - [SwaggerClient::InlineResponse2006](docs/InlineResponse2006.md)
 - [SwaggerClient::InlineResponse2007](docs/InlineResponse2007.md)
 - [SwaggerClient::InlineResponse2008](docs/InlineResponse2008.md)
 - [SwaggerClient::InlineResponse2009](docs/InlineResponse2009.md)
 - [SwaggerClient::_](docs/_.md)


## Documentation for Authorization

 All endpoints do not require authorization.

