# SwaggerClient::AuthAPIApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**auth_login_post**](AuthAPIApi.md#auth_login_post) | **POST** /auth/login | Получить ключ доступа
[**auth_start_get**](AuthAPIApi.md#auth_start_get) | **GET** /auth/start | Получить соль


# **auth_login_post**
> String auth_login_post(login, salt, response)

Получить ключ доступа

Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::AuthAPIApi.new

login = "login_example" # String | Имя пользователя

salt = "salt_example" # String | Соль (см. /auth/start)

response = "response_example" # String | Вычисленный хэш


begin
  #Получить ключ доступа
  result = api_instance.auth_login_post(login, salt, response)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AuthAPIApi->auth_login_post: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **String**| Имя пользователя | 
 **salt** | **String**| Соль (см. /auth/start) | 
 **response** | **String**| Вычисленный хэш | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **auth_start_get**
> String auth_start_get(login)

Получить соль

Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::AuthAPIApi.new

login = "login_example" # String | Имя пользователя


begin
  #Получить соль
  result = api_instance.auth_start_get(login)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AuthAPIApi->auth_start_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **String**| Имя пользователя | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



