# SwaggerClient::DNSApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dns_add_get**](DNSApi.md#dns_add_get) | **GET** /dns/add | Создание записи домена
[**dns_bind_get**](DNSApi.md#dns_bind_get) | **GET** /dns/bind | Привязка одного домена к другому
[**dns_list_get**](DNSApi.md#dns_list_get) | **GET** /dns/list | Получить список доменных имён
[**dns_prolong_list_get**](DNSApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
[**dns_raw_get**](DNSApi.md#dns_raw_get) | **GET** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
[**dns_raw_managedmx_get**](DNSApi.md#dns_raw_managedmx_get) | **GET** /dns/raw/managedmx | Редактировать DNS-зону


# **dns_add_get**
> String dns_add_get(_token_, add_dns_zone, opts)

Создание записи домена

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

add_dns_zone = "add_dns_zone_example" # String | зона, которую необходимо создать

opts = { 
  add_dns_record: "add_dns_record_example", # String | 
  iis_site_for_dns: "iis_site_for_dns_example", # String | ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
  bind_only: true # BOOLEAN | 
}

begin
  #Создание записи домена
  result = api_instance.dns_add_get(_token_, add_dns_zone, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_add_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **add_dns_zone** | **String**| зона, которую необходимо создать | 
 **add_dns_record** | **String**|  | [optional] 
 **iis_site_for_dns** | **String**| ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку | [optional] 
 **bind_only** | **BOOLEAN**|  | [optional] 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_bind_get**
> String dns_bind_get(_token_, _key_, opts)

Привязка одного домена к другому

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID домена из списка /dns/list

opts = { 
  bind_to: "bind_to_example" # String | домен, к которому необходимо сделать привязку
}

begin
  #Привязка одного домена к другому
  result = api_instance.dns_bind_get(_token_, _key_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_bind_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID домена из списка /dns/list | 
 **bind_to** | **String**| домен, к которому необходимо сделать привязку | [optional] 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_list_get**
> Array&lt;InlineResponse2003&gt; dns_list_get(_token_)

Получить список доменных имён

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Получить список доменных имён
  result = api_instance.dns_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2003&gt;**](InlineResponse2003.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_prolong_list_get**
> Array&lt;InlineResponse2004&gt; dns_prolong_list_get(_token_)

Информация по продлению доменов

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Информация по продлению доменов
  result = api_instance.dns_prolong_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_prolong_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2004&gt;**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_raw_get**
> String dns_raw_get(_token_, _key_, s_del, s_add, dns_type, dns_name, dns_value)

Редактирование \"сырой\" зоны

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID домена из /dns/list

s_del = 56 # Integer | Значение '1' сообщает, что запись необходимо удалить

s_add = 56 # Integer | Значение '1' сообщает, что запись необходимо создать

dns_type = "dns_type_example" # String | Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV

dns_name = "dns_name_example" # String | Имя записи, либо '@' для корневой

dns_value = "dns_value_example" # String | Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)


begin
  #Редактирование \"сырой\" зоны
  result = api_instance.dns_raw_get(_token_, _key_, s_del, s_add, dns_type, dns_name, dns_value)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_raw_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID домена из /dns/list | 
 **s_del** | **Integer**| Значение &#39;1&#39; сообщает, что запись необходимо удалить | 
 **s_add** | **Integer**| Значение &#39;1&#39; сообщает, что запись необходимо создать | 
 **dns_type** | **String**| Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV | 
 **dns_name** | **String**| Имя записи, либо &#39;@&#39; для корневой | 
 **dns_value** | **String**| Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_raw_managedmx_get**
> String dns_raw_managedmx_get(_token_, _key_, managed_mx, upd_managed_mx)

Редактировать DNS-зону

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DNSApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID домена из /dns/list

managed_mx = 56 # Integer | Значение '1', если необходимо включить поддержку на MX-серверах хостинга и '0', если выключить

upd_managed_mx = 56 # Integer | Значение '1' подтверждает операцию


begin
  #Редактировать DNS-зону
  result = api_instance.dns_raw_managedmx_get(_token_, _key_, managed_mx, upd_managed_mx)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DNSApi->dns_raw_managedmx_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID домена из /dns/list | 
 **managed_mx** | **Integer**| Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить | 
 **upd_managed_mx** | **Integer**| Значение &#39;1&#39; подтверждает операцию | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



