# SwaggerClient::DefaultApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**balance_get**](DefaultApi.md#balance_get) | **GET** /balance | Аккаунт: баланс
[**balance_lic_get**](DefaultApi.md#balance_lic_get) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
[**billing_debt_get**](DefaultApi.md#billing_debt_get) | **GET** /billing/debt | Информация по дебету аккаунта
[**billing_info_get**](DefaultApi.md#billing_info_get) | **GET** /billing/info | Информация об аккаунте
[**billing_limits_get**](DefaultApi.md#billing_limits_get) | **GET** /billing/limits | Получить ограничения аккаунта
[**dns_prolong_list_get**](DefaultApi.md#dns_prolong_list_get) | **GET** /dns/prolong/list | Информация по продлению доменов
[**email_add_get**](DefaultApi.md#email_add_get) | **GET** /email/add | Создание почтового ящика
[**email_alias_delete_get**](DefaultApi.md#email_alias_delete_get) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
[**email_alias_list_get**](DefaultApi.md#email_alias_list_get) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
[**email_delete_get**](DefaultApi.md#email_delete_get) | **GET** /email/delete | Удаление почтового ящика
[**email_list_get**](DefaultApi.md#email_list_get) | **GET** /email/list | Получить список почтовых ящиков
[**updates_last_get**](DefaultApi.md#updates_last_get) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
[**updates_list_get**](DefaultApi.md#updates_list_get) | **GET** /updates/list | Список записей аудита
[**website_delete_get**](DefaultApi.md#website_delete_get) | **GET** /website/delete | Удаление сайта
[**website_list_get**](DefaultApi.md#website_list_get) | **GET** /website/list | Список сайтов аккаунта


# **balance_get**
> Float balance_get(_token_)

Аккаунт: баланс

Возвращает текущий баланс аккаунта

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Аккаунт: баланс
  result = api_instance.balance_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->balance_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

**Float**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **balance_lic_get**
> Float balance_lic_get(_token_)

Аккаунт: баланс аккаунта лицензий

Возвращает текущий баланс аккаунта лицензий

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Аккаунт: баланс аккаунта лицензий
  result = api_instance.balance_lic_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->balance_lic_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

**Float**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **billing_debt_get**
> Array&lt;InlineResponse200&gt; billing_debt_get(_token_)

Информация по дебету аккаунта

Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Информация по дебету аккаунта
  result = api_instance.billing_debt_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->billing_debt_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse200&gt;**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **billing_info_get**
> Array&lt;InlineResponse2001&gt; billing_info_get(_token_)

Информация об аккаунте

Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Информация об аккаунте
  result = api_instance.billing_info_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->billing_info_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2001&gt;**](InlineResponse2001.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **billing_limits_get**
> _ billing_limits_get(_token_)

Получить ограничения аккаунта

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Получить ограничения аккаунта
  result = api_instance.billing_limits_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->billing_limits_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**_**](_.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **dns_prolong_list_get**
> Array&lt;InlineResponse2004&gt; dns_prolong_list_get(_token_)

Информация по продлению доменов

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Информация по продлению доменов
  result = api_instance.dns_prolong_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->dns_prolong_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2004&gt;**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **email_add_get**
> String email_add_get(_token_, add_email)

Создание почтового ящика

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

add_email = "add_email_example" # String | Адрес почтового ящика, который необходимо создать


begin
  #Создание почтового ящика
  result = api_instance.email_add_get(_token_, add_email)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->email_add_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **add_email** | **String**| Адрес почтового ящика, который необходимо создать | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **email_alias_delete_get**
> String email_alias_delete_get(_token_, _key_)

Удаление псевдонимов почтовых ящиков

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = "_key__example" # String | Адрес почтового ящика, подлежащего удалению


begin
  #Удаление псевдонимов почтовых ящиков
  result = api_instance.email_alias_delete_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->email_alias_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **String**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **email_alias_list_get**
> Array&lt;InlineResponse2005&gt; email_alias_list_get(_token_)

Получить список псевдонимов почтовых ящиков

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Получить список псевдонимов почтовых ящиков
  result = api_instance.email_alias_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->email_alias_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2005&gt;**](InlineResponse2005.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **email_delete_get**
> String email_delete_get(_token_, _key_)

Удаление почтового ящика

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = "_key__example" # String | Адрес почтового ящика, подлежащего удалению


begin
  #Удаление почтового ящика
  result = api_instance.email_delete_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->email_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **String**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **email_list_get**
> Array&lt;InlineResponse2006&gt; email_list_get(_token_)

Получить список почтовых ящиков

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Получить список почтовых ящиков
  result = api_instance.email_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->email_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse2006&gt;**](InlineResponse2006.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **updates_last_get**
> Integer updates_last_get(_token_)

Идентификатор последнего уведомления в аудите

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Идентификатор последнего уведомления в аудите
  result = api_instance.updates_last_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->updates_last_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

**Integer**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **updates_list_get**
> Array&lt;InlineResponse20010&gt; updates_list_get(_token_, _key_)

Список записей аудита

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID первой записи для показа или 0 для показа всех записей


begin
  #Список записей аудита
  result = api_instance.updates_list_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->updates_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID первой записи для показа или 0 для показа всех записей | 

### Return type

[**Array&lt;InlineResponse20010&gt;**](InlineResponse20010.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **website_delete_get**
> String website_delete_get(_token_, _key_)

Удаление сайта

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = "_key__example" # String | ID сайта, полученный из /website/list


begin
  #Удаление сайта
  result = api_instance.website_delete_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->website_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **String**| ID сайта, полученный из /website/list | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **website_list_get**
> Array&lt;InlineResponse20014&gt; website_list_get(_token_)

Список сайтов аккаунта

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::DefaultApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Список сайтов аккаунта
  result = api_instance.website_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling DefaultApi->website_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse20014&gt;**](InlineResponse20014.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



