# SwaggerClient::VDSHyperVOpenVZApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**vds_create_get**](VDSHyperVOpenVZApi.md#vds_create_get) | **GET** /vds/create | Изменение параметров VDS
[**vds_delete_get**](VDSHyperVOpenVZApi.md#vds_delete_get) | **GET** /vds/delete | Удаление VDS
[**vds_ip_add_get**](VDSHyperVOpenVZApi.md#vds_ip_add_get) | **GET** /vds/ip/add | Добавление IP на VDS
[**vds_ip_delete_get**](VDSHyperVOpenVZApi.md#vds_ip_delete_get) | **GET** /vds/ip/delete | Удаление IP с VDS
[**vds_ip_list_get**](VDSHyperVOpenVZApi.md#vds_ip_list_get) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
[**vds_list_get**](VDSHyperVOpenVZApi.md#vds_list_get) | **GET** /vds/list | Список виртуальных серверов
[**vds_reboot_get**](VDSHyperVOpenVZApi.md#vds_reboot_get) | **GET** /vds/reboot | Перезагрузка VDS
[**vds_templates_list_get**](VDSHyperVOpenVZApi.md#vds_templates_list_get) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
[**vds_update_get**](VDSHyperVOpenVZApi.md#vds_update_get) | **GET** /vds/update | Создание VDS


# **vds_create_get**
> String vds_create_get(_token_, opts)

Изменение параметров VDS

Изменение параметров уже существующего VDS

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

opts = { 
  type: "type_example", # String | Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic'
  cr_hvmem: 56, # Integer | Количество доступной памяти в мегабайтах. По умолчанию 2048
  cr_hvdsk: 56, # Integer | Количество доступных гигабайт диска. По умолчанию 30
  cr_hvcpu: 56, # Integer | Количество ядер CPU. По умолчанию 2
  template: "template_example", # String | Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
  force_memo: "force_memo_example", # String | 
  hv_1gb_panel_version: "hv_1gb_panel_version_example", # String | 
  panel_install: true, # BOOLEAN | Необходимо ли установить панель 1Gb на VDS
  cr_ssd1: true, # BOOLEAN | Создать всю систему на SSD
  cr_hv_all_system: true # BOOLEAN | Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
}

begin
  #Изменение параметров VDS
  result = api_instance.vds_create_get(_token_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_create_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **type** | **String**| Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; | [optional] 
 **cr_hvmem** | **Integer**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **cr_hvdsk** | **Integer**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **cr_hvcpu** | **Integer**| Количество ядер CPU. По умолчанию 2 | [optional] 
 **template** | **String**| Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list | [optional] 
 **force_memo** | **String**|  | [optional] 
 **hv_1gb_panel_version** | **String**|  | [optional] 
 **panel_install** | **BOOLEAN**| Необходимо ли установить панель 1Gb на VDS | [optional] 
 **cr_ssd1** | **BOOLEAN**| Создать всю систему на SSD | [optional] 
 **cr_hv_all_system** | **BOOLEAN**| Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) | [optional] 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_delete_get**
> String vds_delete_get(_token_, _key_, opts)

Удаление VDS

Предоставляет функционал для удаления VDS

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID виртуального сервера, полученный из /vds/list

opts = { 
  force_critical: true # BOOLEAN | Если true, VDS будет удален срочно
}

begin
  #Удаление VDS
  result = api_instance.vds_delete_get(_token_, _key_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | 
 **force_critical** | **BOOLEAN**| Если true, VDS будет удален срочно | [optional] 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_ip_add_get**
> String vds_ip_add_get(_token_, _key_)

Добавление IP на VDS

Этот вызов позволяет добавить ещё один IP адрес на указанный VDS

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID виртуального сервера, полученный из /vds/list


begin
  #Добавление IP на VDS
  result = api_instance.vds_ip_add_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_ip_add_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_ip_delete_get**
> String vds_ip_delete_get(_token_, _key_, del_ip)

Удаление IP с VDS

Этот вызов позволяет отвязать IP адрес от VDS

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID виртуального сервера, полученный из /vds/list

del_ip = "del_ip_example" # String | IP адрес, который необходимо удалить


begin
  #Удаление IP с VDS
  result = api_instance.vds_ip_delete_get(_token_, _key_, del_ip)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_ip_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | 
 **del_ip** | **String**| IP адрес, который необходимо удалить | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_ip_list_get**
> Array&lt;InlineResponse20011&gt; vds_ip_list_get(_token_, opts)

Список IP-адресов виртуальных серверов

Список IP-адресов виртуальных серверов

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

opts = { 
  _key_: 56 # Integer | ID виртуального сервера, полученный из /vds/list
}

begin
  #Список IP-адресов виртуальных серверов
  result = api_instance.vds_ip_list_get(_token_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_ip_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | [optional] 

### Return type

[**Array&lt;InlineResponse20011&gt;**](InlineResponse20011.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_list_get**
> Array&lt;InlineResponse20012&gt; vds_list_get(_token_, opts)

Список виртуальных серверов

Позволяет получить список виртуальных серверов

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

opts = { 
  _key_: 56 # Integer | ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
}

begin
  #Список виртуальных серверов
  result = api_instance.vds_list_get(_token_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS | [optional] 

### Return type

[**Array&lt;InlineResponse20012&gt;**](InlineResponse20012.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_reboot_get**
> String vds_reboot_get(_token_, _key_)

Перезагрузка VDS

Предоставляет функционал для перезагрузки VDS

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID виртуального сервера, полученный из /vds/list


begin
  #Перезагрузка VDS
  result = api_instance.vds_reboot_get(_token_, _key_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_reboot_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_templates_list_get**
> Array&lt;InlineResponse20013&gt; vds_templates_list_get(_token_)

Список шаблонов виртуальных серверов

Позволяет получить список шаблонов виртуальных серверов

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации


begin
  #Список шаблонов виртуальных серверов
  result = api_instance.vds_templates_list_get(_token_)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_templates_list_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 

### Return type

[**Array&lt;InlineResponse20013&gt;**](InlineResponse20013.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **vds_update_get**
> String vds_update_get(_token_, _key_, opts)

Создание VDS

Создание новых VDS с произвольными характеристиками

### Example
```ruby
# load the gem
require 'swagger_client'

api_instance = SwaggerClient::VDSHyperVOpenVZApi.new

_token_ = "_token__example" # String | Ключ доступа, полученный при авторизации

_key_ = 56 # Integer | ID виртуального сервера, полученный из /vds/list

opts = { 
  cr_hvmem: 56, # Integer | Количество доступной памяти в мегабайтах. По умолчанию 2048
  cr_hvdsk: 56, # Integer | Количество доступных гигабайт диска. По умолчанию 30
  cr_hvcpu: 56 # Integer | Количество ядер CPU. По умолчанию 2
}

begin
  #Создание VDS
  result = api_instance.vds_update_get(_token_, _key_, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling VDSHyperVOpenVZApi->vds_update_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_token_** | **String**| Ключ доступа, полученный при авторизации | 
 **_key_** | **Integer**| ID виртуального сервера, полученный из /vds/list | 
 **cr_hvmem** | **Integer**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **cr_hvdsk** | **Integer**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **cr_hvcpu** | **Integer**| Количество ядер CPU. По умолчанию 2 | [optional] 

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



