=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module SwaggerClient
  class DefaultApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Аккаунт: баланс
    # Возвращает текущий баланс аккаунта
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Float]
    def balance_get(_token_, opts = {})
      data, _status_code, _headers = balance_get_with_http_info(_token_, opts)
      return data
    end

    # Аккаунт: баланс
    # Возвращает текущий баланс аккаунта
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Float, Fixnum, Hash)>] Float data, response status code and response headers
    def balance_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.balance_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.balance_get" if _token_.nil?
      # resource path
      local_var_path = "/balance".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Float')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#balance_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Аккаунт: баланс аккаунта лицензий
    # Возвращает текущий баланс аккаунта лицензий
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Float]
    def balance_lic_get(_token_, opts = {})
      data, _status_code, _headers = balance_lic_get_with_http_info(_token_, opts)
      return data
    end

    # Аккаунт: баланс аккаунта лицензий
    # Возвращает текущий баланс аккаунта лицензий
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Float, Fixnum, Hash)>] Float data, response status code and response headers
    def balance_lic_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.balance_lic_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.balance_lic_get" if _token_.nil?
      # resource path
      local_var_path = "/balance.lic".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Float')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#balance_lic_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Информация по дебету аккаунта
    # Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse200>]
    def billing_debt_get(_token_, opts = {})
      data, _status_code, _headers = billing_debt_get_with_http_info(_token_, opts)
      return data
    end

    # Информация по дебету аккаунта
    # Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse200>, Fixnum, Hash)>] Array<InlineResponse200> data, response status code and response headers
    def billing_debt_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.billing_debt_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.billing_debt_get" if _token_.nil?
      # resource path
      local_var_path = "/billing/debt".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse200>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#billing_debt_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Информация об аккаунте
    # Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2001>]
    def billing_info_get(_token_, opts = {})
      data, _status_code, _headers = billing_info_get_with_http_info(_token_, opts)
      return data
    end

    # Информация об аккаунте
    # Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2001>, Fixnum, Hash)>] Array<InlineResponse2001> data, response status code and response headers
    def billing_info_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.billing_info_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.billing_info_get" if _token_.nil?
      # resource path
      local_var_path = "/billing/info".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2001>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#billing_info_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Получить ограничения аккаунта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [_]
    def billing_limits_get(_token_, opts = {})
      data, _status_code, _headers = billing_limits_get_with_http_info(_token_, opts)
      return data
    end

    # Получить ограничения аккаунта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(_, Fixnum, Hash)>] _ data, response status code and response headers
    def billing_limits_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.billing_limits_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.billing_limits_get" if _token_.nil?
      # resource path
      local_var_path = "/billing/limits".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => '_')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#billing_limits_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Информация по продлению доменов
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2004>]
    def dns_prolong_list_get(_token_, opts = {})
      data, _status_code, _headers = dns_prolong_list_get_with_http_info(_token_, opts)
      return data
    end

    # Информация по продлению доменов
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2004>, Fixnum, Hash)>] Array<InlineResponse2004> data, response status code and response headers
    def dns_prolong_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.dns_prolong_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.dns_prolong_list_get" if _token_.nil?
      # resource path
      local_var_path = "/dns/prolong/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2004>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#dns_prolong_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Создание почтового ящика
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param add_email Адрес почтового ящика, который необходимо создать
    # @param [Hash] opts the optional parameters
    # @return [String]
    def email_add_get(_token_, add_email, opts = {})
      data, _status_code, _headers = email_add_get_with_http_info(_token_, add_email, opts)
      return data
    end

    # Создание почтового ящика
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param add_email Адрес почтового ящика, который необходимо создать
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def email_add_get_with_http_info(_token_, add_email, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.email_add_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.email_add_get" if _token_.nil?
      # verify the required parameter 'add_email' is set
      fail ArgumentError, "Missing the required parameter 'add_email' when calling DefaultApi.email_add_get" if add_email.nil?
      # resource path
      local_var_path = "/email/add".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'add_email'] = add_email

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#email_add_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Удаление псевдонимов почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ Адрес почтового ящика, подлежащего удалению
    # @param [Hash] opts the optional parameters
    # @return [String]
    def email_alias_delete_get(_token_, _key_, opts = {})
      data, _status_code, _headers = email_alias_delete_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Удаление псевдонимов почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ Адрес почтового ящика, подлежащего удалению
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def email_alias_delete_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.email_alias_delete_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.email_alias_delete_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DefaultApi.email_alias_delete_get" if _key_.nil?
      # resource path
      local_var_path = "/email/alias/delete".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#email_alias_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Получить список псевдонимов почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2005>]
    def email_alias_list_get(_token_, opts = {})
      data, _status_code, _headers = email_alias_list_get_with_http_info(_token_, opts)
      return data
    end

    # Получить список псевдонимов почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2005>, Fixnum, Hash)>] Array<InlineResponse2005> data, response status code and response headers
    def email_alias_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.email_alias_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.email_alias_list_get" if _token_.nil?
      # resource path
      local_var_path = "/email/alias/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2005>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#email_alias_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Удаление почтового ящика
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ Адрес почтового ящика, подлежащего удалению
    # @param [Hash] opts the optional parameters
    # @return [String]
    def email_delete_get(_token_, _key_, opts = {})
      data, _status_code, _headers = email_delete_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Удаление почтового ящика
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ Адрес почтового ящика, подлежащего удалению
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def email_delete_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.email_delete_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.email_delete_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DefaultApi.email_delete_get" if _key_.nil?
      # resource path
      local_var_path = "/email/delete".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#email_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Получить список почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2006>]
    def email_list_get(_token_, opts = {})
      data, _status_code, _headers = email_list_get_with_http_info(_token_, opts)
      return data
    end

    # Получить список почтовых ящиков
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2006>, Fixnum, Hash)>] Array<InlineResponse2006> data, response status code and response headers
    def email_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.email_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.email_list_get" if _token_.nil?
      # resource path
      local_var_path = "/email/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2006>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#email_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Идентификатор последнего уведомления в аудите
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Integer]
    def updates_last_get(_token_, opts = {})
      data, _status_code, _headers = updates_last_get_with_http_info(_token_, opts)
      return data
    end

    # Идентификатор последнего уведомления в аудите
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Integer, Fixnum, Hash)>] Integer data, response status code and response headers
    def updates_last_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.updates_last_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.updates_last_get" if _token_.nil?
      # resource path
      local_var_path = "/updates/last".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Integer')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#updates_last_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Список записей аудита
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID первой записи для показа или 0 для показа всех записей
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20010>]
    def updates_list_get(_token_, _key_, opts = {})
      data, _status_code, _headers = updates_list_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Список записей аудита
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID первой записи для показа или 0 для показа всех записей
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20010>, Fixnum, Hash)>] Array<InlineResponse20010> data, response status code and response headers
    def updates_list_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.updates_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.updates_list_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DefaultApi.updates_list_get" if _key_.nil?
      # resource path
      local_var_path = "/updates/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20010>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#updates_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Удаление сайта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID сайта, полученный из /website/list
    # @param [Hash] opts the optional parameters
    # @return [String]
    def website_delete_get(_token_, _key_, opts = {})
      data, _status_code, _headers = website_delete_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Удаление сайта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID сайта, полученный из /website/list
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def website_delete_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.website_delete_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.website_delete_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DefaultApi.website_delete_get" if _key_.nil?
      # resource path
      local_var_path = "/website/delete".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#website_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Список сайтов аккаунта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20014>]
    def website_list_get(_token_, opts = {})
      data, _status_code, _headers = website_list_get_with_http_info(_token_, opts)
      return data
    end

    # Список сайтов аккаунта
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20014>, Fixnum, Hash)>] Array<InlineResponse20014> data, response status code and response headers
    def website_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DefaultApi.website_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DefaultApi.website_list_get" if _token_.nil?
      # resource path
      local_var_path = "/website/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20014>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#website_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
