=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module SwaggerClient
  class DNSApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Создание записи домена
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param add_dns_zone зона, которую необходимо создать
    # @param [Hash] opts the optional parameters
    # @option opts [String] :add_dns_record 
    # @option opts [String] :iis_site_for_dns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
    # @option opts [BOOLEAN] :bind_only 
    # @return [String]
    def dns_add_get(_token_, add_dns_zone, opts = {})
      data, _status_code, _headers = dns_add_get_with_http_info(_token_, add_dns_zone, opts)
      return data
    end

    # Создание записи домена
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param add_dns_zone зона, которую необходимо создать
    # @param [Hash] opts the optional parameters
    # @option opts [String] :add_dns_record 
    # @option opts [String] :iis_site_for_dns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
    # @option opts [BOOLEAN] :bind_only 
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def dns_add_get_with_http_info(_token_, add_dns_zone, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_add_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_add_get" if _token_.nil?
      # verify the required parameter 'add_dns_zone' is set
      fail ArgumentError, "Missing the required parameter 'add_dns_zone' when calling DNSApi.dns_add_get" if add_dns_zone.nil?
      # resource path
      local_var_path = "/dns/add".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'add_dns_zone'] = add_dns_zone
      query_params[:'add_dns_record'] = opts[:'add_dns_record'] if !opts[:'add_dns_record'].nil?
      query_params[:'iis_site_for_dns'] = opts[:'iis_site_for_dns'] if !opts[:'iis_site_for_dns'].nil?
      query_params[:'bind_only'] = opts[:'bind_only'] if !opts[:'bind_only'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_add_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Привязка одного домена к другому
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из списка /dns/list
    # @param [Hash] opts the optional parameters
    # @option opts [String] :bind_to домен, к которому необходимо сделать привязку
    # @return [String]
    def dns_bind_get(_token_, _key_, opts = {})
      data, _status_code, _headers = dns_bind_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Привязка одного домена к другому
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из списка /dns/list
    # @param [Hash] opts the optional parameters
    # @option opts [String] :bind_to домен, к которому необходимо сделать привязку
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def dns_bind_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_bind_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_bind_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DNSApi.dns_bind_get" if _key_.nil?
      # resource path
      local_var_path = "/dns/bind".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'bind_to'] = opts[:'bind_to'] if !opts[:'bind_to'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_bind_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Получить список доменных имён
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2003>]
    def dns_list_get(_token_, opts = {})
      data, _status_code, _headers = dns_list_get_with_http_info(_token_, opts)
      return data
    end

    # Получить список доменных имён
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2003>, Fixnum, Hash)>] Array<InlineResponse2003> data, response status code and response headers
    def dns_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_list_get" if _token_.nil?
      # resource path
      local_var_path = "/dns/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2003>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Информация по продлению доменов
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2004>]
    def dns_prolong_list_get(_token_, opts = {})
      data, _status_code, _headers = dns_prolong_list_get_with_http_info(_token_, opts)
      return data
    end

    # Информация по продлению доменов
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2004>, Fixnum, Hash)>] Array<InlineResponse2004> data, response status code and response headers
    def dns_prolong_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_prolong_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_prolong_list_get" if _token_.nil?
      # resource path
      local_var_path = "/dns/prolong/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2004>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_prolong_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Редактирование \"сырой\" зоны
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из /dns/list
    # @param s_del Значение &#39;1&#39; сообщает, что запись необходимо удалить
    # @param s_add Значение &#39;1&#39; сообщает, что запись необходимо создать
    # @param dns_type Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
    # @param dns_name Имя записи, либо &#39;@&#39; для корневой
    # @param dns_value Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
    # @param [Hash] opts the optional parameters
    # @return [String]
    def dns_raw_get(_token_, _key_, s_del, s_add, dns_type, dns_name, dns_value, opts = {})
      data, _status_code, _headers = dns_raw_get_with_http_info(_token_, _key_, s_del, s_add, dns_type, dns_name, dns_value, opts)
      return data
    end

    # Редактирование \&quot;сырой\&quot; зоны
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из /dns/list
    # @param s_del Значение &#39;1&#39; сообщает, что запись необходимо удалить
    # @param s_add Значение &#39;1&#39; сообщает, что запись необходимо создать
    # @param dns_type Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
    # @param dns_name Имя записи, либо &#39;@&#39; для корневой
    # @param dns_value Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def dns_raw_get_with_http_info(_token_, _key_, s_del, s_add, dns_type, dns_name, dns_value, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_raw_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_raw_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DNSApi.dns_raw_get" if _key_.nil?
      # verify the required parameter 's_del' is set
      fail ArgumentError, "Missing the required parameter 's_del' when calling DNSApi.dns_raw_get" if s_del.nil?
      # verify the required parameter 's_add' is set
      fail ArgumentError, "Missing the required parameter 's_add' when calling DNSApi.dns_raw_get" if s_add.nil?
      # verify the required parameter 'dns_type' is set
      fail ArgumentError, "Missing the required parameter 'dns_type' when calling DNSApi.dns_raw_get" if dns_type.nil?
      # verify the required parameter 'dns_name' is set
      fail ArgumentError, "Missing the required parameter 'dns_name' when calling DNSApi.dns_raw_get" if dns_name.nil?
      # verify the required parameter 'dns_value' is set
      fail ArgumentError, "Missing the required parameter 'dns_value' when calling DNSApi.dns_raw_get" if dns_value.nil?
      # resource path
      local_var_path = "/dns/raw".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'s_del'] = s_del
      query_params[:'s_add'] = s_add
      query_params[:'dns_type'] = dns_type
      query_params[:'dns_name'] = dns_name
      query_params[:'dns_value'] = dns_value

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_raw_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Редактировать DNS-зону
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из /dns/list
    # @param managed_mx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
    # @param upd_managed_mx Значение &#39;1&#39; подтверждает операцию
    # @param [Hash] opts the optional parameters
    # @return [String]
    def dns_raw_managedmx_get(_token_, _key_, managed_mx, upd_managed_mx, opts = {})
      data, _status_code, _headers = dns_raw_managedmx_get_with_http_info(_token_, _key_, managed_mx, upd_managed_mx, opts)
      return data
    end

    # Редактировать DNS-зону
    # 
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID домена из /dns/list
    # @param managed_mx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
    # @param upd_managed_mx Значение &#39;1&#39; подтверждает операцию
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def dns_raw_managedmx_get_with_http_info(_token_, _key_, managed_mx, upd_managed_mx, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DNSApi.dns_raw_managedmx_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling DNSApi.dns_raw_managedmx_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling DNSApi.dns_raw_managedmx_get" if _key_.nil?
      # verify the required parameter 'managed_mx' is set
      fail ArgumentError, "Missing the required parameter 'managed_mx' when calling DNSApi.dns_raw_managedmx_get" if managed_mx.nil?
      # verify the required parameter 'upd_managed_mx' is set
      fail ArgumentError, "Missing the required parameter 'upd_managed_mx' when calling DNSApi.dns_raw_managedmx_get" if upd_managed_mx.nil?
      # resource path
      local_var_path = "/dns/raw/managedmx".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'managed_mx'] = managed_mx
      query_params[:'upd_managed_mx'] = upd_managed_mx

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DNSApi#dns_raw_managedmx_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
