=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module SwaggerClient
  class VDSHyperVOpenVZApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Изменение параметров VDS
    # Изменение параметров уже существующего VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [String] :type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
    # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
    # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
    # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
    # @option opts [String] :template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
    # @option opts [String] :force_memo 
    # @option opts [String] :hv_1gb_panel_version 
    # @option opts [BOOLEAN] :panel_install Необходимо ли установить панель 1Gb на VDS
    # @option opts [BOOLEAN] :cr_ssd1 Создать всю систему на SSD
    # @option opts [BOOLEAN] :cr_hv_all_system Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
    # @return [String]
    def vds_create_get(_token_, opts = {})
      data, _status_code, _headers = vds_create_get_with_http_info(_token_, opts)
      return data
    end

    # Изменение параметров VDS
    # Изменение параметров уже существующего VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [String] :type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
    # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
    # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
    # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
    # @option opts [String] :template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
    # @option opts [String] :force_memo 
    # @option opts [String] :hv_1gb_panel_version 
    # @option opts [BOOLEAN] :panel_install Необходимо ли установить панель 1Gb на VDS
    # @option opts [BOOLEAN] :cr_ssd1 Создать всю систему на SSD
    # @option opts [BOOLEAN] :cr_hv_all_system Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_create_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_create_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_create_get" if _token_.nil?
      # resource path
      local_var_path = "/vds/create".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?
      query_params[:'cr_hvmem'] = opts[:'cr_hvmem'] if !opts[:'cr_hvmem'].nil?
      query_params[:'cr_hvdsk'] = opts[:'cr_hvdsk'] if !opts[:'cr_hvdsk'].nil?
      query_params[:'cr_hvcpu'] = opts[:'cr_hvcpu'] if !opts[:'cr_hvcpu'].nil?
      query_params[:'template'] = opts[:'template'] if !opts[:'template'].nil?
      query_params[:'force_memo'] = opts[:'force_memo'] if !opts[:'force_memo'].nil?
      query_params[:'hv_1gb_panel_version'] = opts[:'hv_1gb_panel_version'] if !opts[:'hv_1gb_panel_version'].nil?
      query_params[:'panel_install'] = opts[:'panel_install'] if !opts[:'panel_install'].nil?
      query_params[:'cr_ssd1'] = opts[:'cr_ssd1'] if !opts[:'cr_ssd1'].nil?
      query_params[:'cr_hv_all_system'] = opts[:'cr_hv_all_system'] if !opts[:'cr_hv_all_system'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_create_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Удаление VDS
    # Предоставляет функционал для удаления VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force_critical Если true, VDS будет удален срочно
    # @return [String]
    def vds_delete_get(_token_, _key_, opts = {})
      data, _status_code, _headers = vds_delete_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Удаление VDS
    # Предоставляет функционал для удаления VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force_critical Если true, VDS будет удален срочно
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_delete_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_delete_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_delete_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling VDSHyperVOpenVZApi.vds_delete_get" if _key_.nil?
      # resource path
      local_var_path = "/vds/delete".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'force_critical'] = opts[:'force_critical'] if !opts[:'force_critical'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Добавление IP на VDS
    # Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @return [String]
    def vds_ip_add_get(_token_, _key_, opts = {})
      data, _status_code, _headers = vds_ip_add_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Добавление IP на VDS
    # Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_ip_add_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_ip_add_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_ip_add_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling VDSHyperVOpenVZApi.vds_ip_add_get" if _key_.nil?
      # resource path
      local_var_path = "/vds/ip/add".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_ip_add_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Удаление IP с VDS
    # Этот вызов позволяет отвязать IP адрес от VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param del_ip IP адрес, который необходимо удалить
    # @param [Hash] opts the optional parameters
    # @return [String]
    def vds_ip_delete_get(_token_, _key_, del_ip, opts = {})
      data, _status_code, _headers = vds_ip_delete_get_with_http_info(_token_, _key_, del_ip, opts)
      return data
    end

    # Удаление IP с VDS
    # Этот вызов позволяет отвязать IP адрес от VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param del_ip IP адрес, который необходимо удалить
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_ip_delete_get_with_http_info(_token_, _key_, del_ip, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_ip_delete_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_ip_delete_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling VDSHyperVOpenVZApi.vds_ip_delete_get" if _key_.nil?
      # verify the required parameter 'del_ip' is set
      fail ArgumentError, "Missing the required parameter 'del_ip' when calling VDSHyperVOpenVZApi.vds_ip_delete_get" if del_ip.nil?
      # resource path
      local_var_path = "/vds/ip/delete".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'del_ip'] = del_ip

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_ip_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Список IP-адресов виртуальных серверов
    # Список IP-адресов виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :_key_ ID виртуального сервера, полученный из /vds/list
    # @return [Array<InlineResponse20011>]
    def vds_ip_list_get(_token_, opts = {})
      data, _status_code, _headers = vds_ip_list_get_with_http_info(_token_, opts)
      return data
    end

    # Список IP-адресов виртуальных серверов
    # Список IP-адресов виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :_key_ ID виртуального сервера, полученный из /vds/list
    # @return [Array<(Array<InlineResponse20011>, Fixnum, Hash)>] Array<InlineResponse20011> data, response status code and response headers
    def vds_ip_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_ip_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_ip_list_get" if _token_.nil?
      # resource path
      local_var_path = "/vds/ip/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = opts[:'_key_'] if !opts[:'_key_'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20011>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_ip_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Список виртуальных серверов
    # Позволяет получить список виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :_key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
    # @return [Array<InlineResponse20012>]
    def vds_list_get(_token_, opts = {})
      data, _status_code, _headers = vds_list_get_with_http_info(_token_, opts)
      return data
    end

    # Список виртуальных серверов
    # Позволяет получить список виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :_key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
    # @return [Array<(Array<InlineResponse20012>, Fixnum, Hash)>] Array<InlineResponse20012> data, response status code and response headers
    def vds_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_list_get" if _token_.nil?
      # resource path
      local_var_path = "/vds/list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = opts[:'_key_'] if !opts[:'_key_'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20012>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Перезагрузка VDS
    # Предоставляет функционал для перезагрузки VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @return [String]
    def vds_reboot_get(_token_, _key_, opts = {})
      data, _status_code, _headers = vds_reboot_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Перезагрузка VDS
    # Предоставляет функционал для перезагрузки VDS
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_reboot_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_reboot_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_reboot_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling VDSHyperVOpenVZApi.vds_reboot_get" if _key_.nil?
      # resource path
      local_var_path = "/vds/reboot".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_reboot_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Список шаблонов виртуальных серверов
    # Позволяет получить список шаблонов виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20013>]
    def vds_templates_list_get(_token_, opts = {})
      data, _status_code, _headers = vds_templates_list_get_with_http_info(_token_, opts)
      return data
    end

    # Список шаблонов виртуальных серверов
    # Позволяет получить список шаблонов виртуальных серверов
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20013>, Fixnum, Hash)>] Array<InlineResponse20013> data, response status code and response headers
    def vds_templates_list_get_with_http_info(_token_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_templates_list_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_templates_list_get" if _token_.nil?
      # resource path
      local_var_path = "/vds/templates-list".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20013>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_templates_list_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Создание VDS
    # Создание новых VDS с произвольными характеристиками
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
    # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
    # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
    # @return [String]
    def vds_update_get(_token_, _key_, opts = {})
      data, _status_code, _headers = vds_update_get_with_http_info(_token_, _key_, opts)
      return data
    end

    # Создание VDS
    # Создание новых VDS с произвольными характеристиками
    # @param _token_ Ключ доступа, полученный при авторизации
    # @param _key_ ID виртуального сервера, полученный из /vds/list
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
    # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
    # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def vds_update_get_with_http_info(_token_, _key_, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: VDSHyperVOpenVZApi.vds_update_get ..."
      end
      # verify the required parameter '_token_' is set
      fail ArgumentError, "Missing the required parameter '_token_' when calling VDSHyperVOpenVZApi.vds_update_get" if _token_.nil?
      # verify the required parameter '_key_' is set
      fail ArgumentError, "Missing the required parameter '_key_' when calling VDSHyperVOpenVZApi.vds_update_get" if _key_.nil?
      # resource path
      local_var_path = "/vds/update".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'_token_'] = _token_
      query_params[:'_key_'] = _key_
      query_params[:'cr_hvmem'] = opts[:'cr_hvmem'] if !opts[:'cr_hvmem'].nil?
      query_params[:'cr_hvdsk'] = opts[:'cr_hvdsk'] if !opts[:'cr_hvdsk'].nil?
      query_params[:'cr_hvcpu'] = opts[:'cr_hvcpu'] if !opts[:'cr_hvcpu'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: VDSHyperVOpenVZApi#vds_update_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
