=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'spec_helper'
require 'json'

# Unit tests for SwaggerClient::DefaultApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'DefaultApi' do
  before do
    # run before each test
    @instance = SwaggerClient::DefaultApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of DefaultApi' do
    it 'should create an instact of DefaultApi' do
      expect(@instance).to be_instance_of(SwaggerClient::DefaultApi)
    end
  end

  # unit tests for balance_get
  # Аккаунт: баланс
  # Возвращает текущий баланс аккаунта
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Float]
  describe 'balance_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for balance_lic_get
  # Аккаунт: баланс аккаунта лицензий
  # Возвращает текущий баланс аккаунта лицензий
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Float]
  describe 'balance_lic_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for billing_debt_get
  # Информация по дебету аккаунта
  # Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse200>]
  describe 'billing_debt_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for billing_info_get
  # Информация об аккаунте
  # Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2001>]
  describe 'billing_info_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for billing_limits_get
  # Получить ограничения аккаунта
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [_]
  describe 'billing_limits_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_prolong_list_get
  # Информация по продлению доменов
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2004>]
  describe 'dns_prolong_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for email_add_get
  # Создание почтового ящика
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param add_email Адрес почтового ящика, который необходимо создать
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'email_add_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for email_alias_delete_get
  # Удаление псевдонимов почтовых ящиков
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ Адрес почтового ящика, подлежащего удалению
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'email_alias_delete_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for email_alias_list_get
  # Получить список псевдонимов почтовых ящиков
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2005>]
  describe 'email_alias_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for email_delete_get
  # Удаление почтового ящика
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ Адрес почтового ящика, подлежащего удалению
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'email_delete_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for email_list_get
  # Получить список почтовых ящиков
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2006>]
  describe 'email_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for updates_last_get
  # Идентификатор последнего уведомления в аудите
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Integer]
  describe 'updates_last_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for updates_list_get
  # Список записей аудита
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID первой записи для показа или 0 для показа всех записей
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse20010>]
  describe 'updates_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for website_delete_get
  # Удаление сайта
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID сайта, полученный из /website/list
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'website_delete_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for website_list_get
  # Список сайтов аккаунта
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse20014>]
  describe 'website_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
