=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'spec_helper'
require 'json'

# Unit tests for SwaggerClient::DNSApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'DNSApi' do
  before do
    # run before each test
    @instance = SwaggerClient::DNSApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of DNSApi' do
    it 'should create an instact of DNSApi' do
      expect(@instance).to be_instance_of(SwaggerClient::DNSApi)
    end
  end

  # unit tests for dns_add_get
  # Создание записи домена
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param add_dns_zone зона, которую необходимо создать
  # @param [Hash] opts the optional parameters
  # @option opts [String] :add_dns_record 
  # @option opts [String] :iis_site_for_dns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
  # @option opts [BOOLEAN] :bind_only 
  # @return [String]
  describe 'dns_add_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_bind_get
  # Привязка одного домена к другому
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID домена из списка /dns/list
  # @param [Hash] opts the optional parameters
  # @option opts [String] :bind_to домен, к которому необходимо сделать привязку
  # @return [String]
  describe 'dns_bind_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_list_get
  # Получить список доменных имён
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2003>]
  describe 'dns_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_prolong_list_get
  # Информация по продлению доменов
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse2004>]
  describe 'dns_prolong_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_raw_get
  # Редактирование \&quot;сырой\&quot; зоны
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID домена из /dns/list
  # @param s_del Значение &#39;1&#39; сообщает, что запись необходимо удалить
  # @param s_add Значение &#39;1&#39; сообщает, что запись необходимо создать
  # @param dns_type Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
  # @param dns_name Имя записи, либо &#39;@&#39; для корневой
  # @param dns_value Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'dns_raw_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for dns_raw_managedmx_get
  # Редактировать DNS-зону
  # 
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID домена из /dns/list
  # @param managed_mx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
  # @param upd_managed_mx Значение &#39;1&#39; подтверждает операцию
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'dns_raw_managedmx_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
