=begin
#1Gb API

# API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'spec_helper'
require 'json'

# Unit tests for SwaggerClient::VDSHyperVOpenVZApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'VDSHyperVOpenVZApi' do
  before do
    # run before each test
    @instance = SwaggerClient::VDSHyperVOpenVZApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of VDSHyperVOpenVZApi' do
    it 'should create an instact of VDSHyperVOpenVZApi' do
      expect(@instance).to be_instance_of(SwaggerClient::VDSHyperVOpenVZApi)
    end
  end

  # unit tests for vds_create_get
  # Изменение параметров VDS
  # Изменение параметров уже существующего VDS
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @option opts [String] :type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
  # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
  # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
  # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
  # @option opts [String] :template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
  # @option opts [String] :force_memo 
  # @option opts [String] :hv_1gb_panel_version 
  # @option opts [BOOLEAN] :panel_install Необходимо ли установить панель 1Gb на VDS
  # @option opts [BOOLEAN] :cr_ssd1 Создать всю систему на SSD
  # @option opts [BOOLEAN] :cr_hv_all_system Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
  # @return [String]
  describe 'vds_create_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_delete_get
  # Удаление VDS
  # Предоставляет функционал для удаления VDS
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID виртуального сервера, полученный из /vds/list
  # @param [Hash] opts the optional parameters
  # @option opts [BOOLEAN] :force_critical Если true, VDS будет удален срочно
  # @return [String]
  describe 'vds_delete_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_ip_add_get
  # Добавление IP на VDS
  # Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID виртуального сервера, полученный из /vds/list
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'vds_ip_add_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_ip_delete_get
  # Удаление IP с VDS
  # Этот вызов позволяет отвязать IP адрес от VDS
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID виртуального сервера, полученный из /vds/list
  # @param del_ip IP адрес, который необходимо удалить
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'vds_ip_delete_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_ip_list_get
  # Список IP-адресов виртуальных серверов
  # Список IP-адресов виртуальных серверов
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :_key_ ID виртуального сервера, полученный из /vds/list
  # @return [Array<InlineResponse20011>]
  describe 'vds_ip_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_list_get
  # Список виртуальных серверов
  # Позволяет получить список виртуальных серверов
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :_key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
  # @return [Array<InlineResponse20012>]
  describe 'vds_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_reboot_get
  # Перезагрузка VDS
  # Предоставляет функционал для перезагрузки VDS
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID виртуального сервера, полученный из /vds/list
  # @param [Hash] opts the optional parameters
  # @return [String]
  describe 'vds_reboot_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_templates_list_get
  # Список шаблонов виртуальных серверов
  # Позволяет получить список шаблонов виртуальных серверов
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param [Hash] opts the optional parameters
  # @return [Array<InlineResponse20013>]
  describe 'vds_templates_list_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for vds_update_get
  # Создание VDS
  # Создание новых VDS с произвольными характеристиками
  # @param _token_ Ключ доступа, полученный при авторизации
  # @param _key_ ID виртуального сервера, полученный из /vds/list
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :cr_hvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
  # @option opts [Integer] :cr_hvdsk Количество доступных гигабайт диска. По умолчанию 30
  # @option opts [Integer] :cr_hvcpu Количество ядер CPU. По умолчанию 2
  # @return [String]
  describe 'vds_update_get test' do
    it "should work" do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
